import socket
import datetime

class Timer:
    def __init__(self, timeout):
        self.timeout = timeout
        self.start = datetime.datetime.utcnow()

    def is_timeout(self):
        return (self.start + datetime.timedelta(seconds=self.timeout) <
                datetime.datetime.utcnow())

with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
    s.bind(('127.0.0.1', 8001))
    s.listen()
    while True:
        conn, addr = s.accept()
        print('Got connection from: ', addr)
        timeout = Timer(timeout=2)
        while not timeout.is_timeout():
            data = conn.recv(1024)
            if not data:
                continue
            print('Got message: ', data)
        try:
            conn.shutdown(socket.SHUT_RD)
        except OSError:
            pass
        conn.close()
